Attribute VB_Name = "Module1"
Global PrgRun As Boolean 'Flag = Programm luft

Private hrc As Long 'Handle fr den OpenGL Gertekontext
Public Sub Main()
   Dim frm As Form
   
   PrgRun = True 'Flag = das Programm luft
   Set frm = New Form1 'Fenster fr OpenGL-Ausgabe
   frm.ScaleMode = vbPixels 'das Fenster mu zwingend in Pixel bemessen werden
   
   If CreateGLWindow(frm, 640, 480, 16) Then 'Fenster initialisieren
      Do 'Endlosschleife in der das Fenster laufend gelscht und neu aufgebaut wird.
         'Die Laufzeit dieser Schleife ist ausschlaggebend, wieviele Objekt gezeichnet werden knnen
         glClear clrColorBufferBit Or clrDepthBufferBit ' lscht das Fenster und den Tiefenpuffer
         glLoadIdentity 'setzt die aktuelle Modell-Matrix zurck
         SwapBuffers (frm.hDC) 'Puffer tauschen (Double Buffering)
         DoEvents
      Loop While PrgRun 'Programm nur beenden, wenn PrgRun = False
      'PrgRun ist Global definiert und wird im KeyDown-Ereignis von Form1 bei drcken von Escape gesetzt.
      'alles freigeben und Programm beenden
      If hrc <> 0 Then 'hatten wir einen Gertekontext fr OpenGL?
         wglMakeCurrent 0, 0 'Freigeben des Gertekontexts
         wglDeleteContext (hrc) 'Freigeben des Renderingkontexts
      End If
      Unload frm
      Set frm = Nothing
      End
   End If
End Sub

Public Function CreateGLWindow(frm As Form, Width As Integer, Height As Integer, Bits As Integer) As Boolean
   Dim pfd As PIXELFORMATDESCRIPTOR ' pfd erklrt Windows, wie das Fenster beschaffen sein soll
   Dim PixelFormat As GLuint ' enthlt das Ergebnis vom Versuch, ein Fenster mit den gegebenen Parametern zu erstellen
      
   pfd.cColorBits = Bits 'Farbtiefe
   pfd.cDepthBits = 16 '16 Bit Tiefenpuffer
   'Der Tiefenpuffer enthlt die Entfernung eines Pixels zur Kamera (Betrachter).
   'Er verhindert, da Objekte im Hintergrund beim Zeichnen Objekte im Vordergund berlagern.
   pfd.dwFlags = PFD_DRAW_TO_WINDOW Or PFD_SUPPORT_OPENGL Or PFD_DOUBLEBUFFER
   'PFD_DRAW_TO_WINDOW = das Format mu als Fenster sichtbar sein knnen
   'PFD_SUPPORT_OPENGL = das Format mu OpenGL untersttzen
   'PFD_DOUBLEBUFFER = das Foramt mu Double Buffering untersttzen
   pfd.iLayerType = PFD_MAIN_PLANE 'Die Hauptebene auf der gezeichnt wird.
   pfd.iPixelType = PFD_TYPE_RGBA 'Pixel werden im RGBA Modus dargestellt.
   'RGB ist mit VB identisch. Fr A wird ein Alpha-Wert fr die Transparenz bergeben
   pfd.nSize = Len(pfd) 'Gre der Struktur sollte natrlich stimmen
   pfd.nVersion = 1 'Versionsnummer

   PixelFormat = ChoosePixelFormat(frm.hDC, pfd) 'Windows nach einem oben beschriebenen Pixelformat fragen
   If PixelFormat <> 0 Then
      'Windows hat ein entsprechendes Format gefunden
      If SetPixelFormat(frm.hDC, PixelFormat, pfd) <> 0 Then
         'Einrichten des Pixelformates war erfolgreich
         hrc = wglCreateContext(frm.hDC)
         If hrc <> 0 Then
            'ein Rendering Kontext wurde erstellt
            If wglMakeCurrent(frm.hDC, hrc) <> 0 Then
               'Der Kontext wurde aktiviert
               frm.Show 'Fenster anzeigen
               glShadeModel smSmooth 'schaltet schne Farbbergange ein
               glClearColor 0#, 0#, 0#, 0# 'schwarzer Hintergrund
               glClearDepth 1# 'Tiefenpuffer zurcksetzten (spter mehr)
               glEnable glcDepthTest 'Aktivierung des Tiefentests (spter mehr)
               glDepthFunc cfLEqual 'Typ des Tiefentests (spter mehr)
               glHint htPerspectiveCorrectionHint, hmNicest 'Art der Perspectivenansicht
               'hmNicest = beste Ansicht / hmFastest = schnellste Darstellung
               CreateGLWindow = True
            End If
         End If
      End If
   End If
End Function
